" =============================================================================
" URL: https://github.com/sainnhe/gruvbox-material/
" Filename: autoload/airline/themes/gruvbox_material.vim
" Author: Sainnhepark
" Email: sainnhe@gmail.com
" License: MIT License & Anti-996 License
" =============================================================================

if &background ==# 'light'
    if get(g:, 'gruvbox_material_background', 'medium') ==# 'hard'
        let s:darker    = '#fbf1c7'
        let s:darkgrey  = '#ebdbb2'
    elseif get(g:, 'gruvbox_material_background', 'medium') ==# 'medium'
        let s:darker    = '#f2e5bc'
        let s:darkgrey  = '#ddccab'
    elseif get(g:, 'gruvbox_material_background', 'medium') ==# 'soft'
        let s:darker    = '#ebdbb2'
        let s:darkgrey  = '#d5c4a1'
    endif
else
    if get(g:, 'gruvbox_material_background', 'medium') ==# 'hard'
        let s:darker    = '#282828'
        let s:darkgrey  = '#504945'
        let s:darker_cterm    = 235
        let s:darkgrey_cterm  = 239
    elseif get(g:, 'gruvbox_material_background', 'medium') ==# 'medium'
        let s:darker    = '#32302f'
        let s:darkgrey  = '#5a524c'
        let s:darker_cterm    = 236
        let s:darkgrey_cterm  = 240
    elseif get(g:, 'gruvbox_material_background', 'medium') ==# 'soft'
        let s:darker    = '#3c3836'
        let s:darkgrey  = '#665c54'
        let s:darker_cterm    = 237
        let s:darkgrey_cterm  = 241
    endif
endif

if &background ==# 'light'
    let g:airline#themes#gruvbox_material#palette = {}
    let g:airline#themes#gruvbox_material#palette.accents = {
                \ 'red': [ '#ae5858' , '' , 88 , '' , '' ],
                \ }

    " Normal mode
    let s:N1 = [ '#ebdbb2' , '#7c6f64' , 223 , 243 ] " mode
    let s:N2 = [ '#4f3829' , s:darkgrey , 241 , 250 ] " info
    let s:N3 = [ '#4f3829' , s:darker , 241 , 223 ] " statusline

    let g:airline#themes#gruvbox_material#palette.normal = airline#themes#generate_color_map(s:N1, s:N2, s:N3)
    let g:airline#themes#gruvbox_material#palette.normal_modified = {
                \ 'airline_c': [ '#4f3829' , s:darker , 241 , 223 ] ,
                \ }

    " Insert mode
    let s:I1 = [ '#ebdbb2' , '#6f8352' , 223 , 100 ]
    let s:I2 = [ '#4f3829' , s:darkgrey , 241 , 250 ]
    let s:I3 = [ '#4f3829' , s:darker , 241 , 223 ]

    let g:airline#themes#gruvbox_material#palette.insert = airline#themes#generate_color_map(s:I1, s:I2, s:I3)
    let g:airline#themes#gruvbox_material#palette.insert_modified = {
                \ 'airline_c': [ '#4f3829' , s:darker , 241 , 223 ] ,
                \ }

    " Replace mode
    let s:R1 = [ '#ebdbb2' , '#a96b2c' , 223 , 130 ]
    let s:R2 = [ '#4f3829' , s:darkgrey , 241 , 250 ]
    let s:R3 = [ '#4f3829' , s:darker , 241 , 223 ]

    let g:airline#themes#gruvbox_material#palette.replace = airline#themes#generate_color_map(s:R1, s:R2, s:R3)
    let g:airline#themes#gruvbox_material#palette.replace_modified = {
                \ 'airline_c': [ '#4f3829' , s:darker , 241 , 223 ] ,
                \ }

    " Visual mode
    let s:V1 = [ '#ebdbb2' , '#ae5858' , 223 , 88 ]
    let s:V2 = [ '#4f3829' , s:darkgrey , 241 , 250 ]
    let s:V3 = [ '#4f3829' , s:darker , 241 , 223 ]

    let g:airline#themes#gruvbox_material#palette.visual = airline#themes#generate_color_map(s:V1, s:V2, s:V3)
    let g:airline#themes#gruvbox_material#palette.visual_modified = {
                \ 'airline_c': [ '#4f3829' , s:darker , 241 , 223 ] ,
                \ }

    " Inactive
    let s:IA = [ '#4f3829' , s:darker , 241 , 223 ]
    let g:airline#themes#gruvbox_material#palette.inactive = airline#themes#generate_color_map(s:IA, s:IA, s:IA)
    let g:airline#themes#gruvbox_material#palette.inactive_modified = {
                \ 'airline_c': [ '#4f3829' , s:darker , 241 , 223 ] ,
                \ }
else
    let g:airline#themes#gruvbox_material#palette = {}
    let g:airline#themes#gruvbox_material#palette.accents = {
                \ 'red': [ '#ea6962' , '' , 167 , '' , '' ],
                \ }

    " Normal mode
    let s:N1 = [ '#282828' , '#a89984' , 235 , 246 ] " mode
    let s:N2 = [ '#ddc7a1' , s:darkgrey , 223 , s:darkgrey_cterm ] " info
    let s:N3 = [ '#ddc7a1' , s:darker , 223 , s:darker_cterm ] " statusline

    let g:airline#themes#gruvbox_material#palette.normal = airline#themes#generate_color_map(s:N1, s:N2, s:N3)
    let g:airline#themes#gruvbox_material#palette.normal_modified = {
                \ 'airline_c': [ '#ddc7a1' , s:darker , 223 , s:darker_cterm ] ,
                \ }

    " Insert mode
    let s:I1 = [ '#282828' , '#a9b665' , 235 , 142 ]
    let s:I2 = [ '#ddc7a1' , s:darkgrey , 223 , s:darkgrey_cterm ]
    let s:I3 = [ '#ddc7a1' , s:darker , 223 , s:darker_cterm ]

    let g:airline#themes#gruvbox_material#palette.insert = airline#themes#generate_color_map(s:I1, s:I2, s:I3)
    let g:airline#themes#gruvbox_material#palette.insert_modified = {
                \ 'airline_c': [ '#ddc7a1' , s:darker , 223 , s:darker_cterm ] ,
                \ }

    " Replace mode
    let s:R1 = [ '#282828' , '#e78a4e' , 235 , 208 ]
    let s:R2 = [ '#ddc7a1' , s:darkgrey , 223 , s:darkgrey_cterm ]
    let s:R3 = [ '#ddc7a1' , s:darker , 223 , s:darker_cterm ]

    let g:airline#themes#gruvbox_material#palette.replace = airline#themes#generate_color_map(s:R1, s:R2, s:R3)
    let g:airline#themes#gruvbox_material#palette.replace_modified = {
                \ 'airline_c': [ '#ddc7a1' , s:darker , 223 , s:darker_cterm ] ,
                \ }

    " Visual mode
    let s:V1 = [ '#282828' , '#ea6962' , 235 , 167 ]
    let s:V2 = [ '#ddc7a1' , s:darkgrey , 223 , s:darkgrey_cterm ]
    let s:V3 = [ '#ddc7a1' , s:darker , 223 , s:darker_cterm ]

    let g:airline#themes#gruvbox_material#palette.visual = airline#themes#generate_color_map(s:V1, s:V2, s:V3)
    let g:airline#themes#gruvbox_material#palette.visual_modified = {
                \ 'airline_c': [ '#ddc7a1' , s:darker , 223 , s:darker_cterm ] ,
                \ }

    " Inactive
    let s:IA = [ '#ddc7a1' , s:darker , 223 , s:darker_cterm ]
    let g:airline#themes#gruvbox_material#palette.inactive = airline#themes#generate_color_map(s:IA, s:IA, s:IA)
    let g:airline#themes#gruvbox_material#palette.inactive_modified = {
                \ 'airline_c': [ '#ddc7a1' , s:darker , 223 , s:darker_cterm ] ,
                \ }
endif
